From c0b3d9f055a91bc73fd541bc415e18a98fd46978 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:24:39 +0000
Subject: [PATCH 811/2232] Try finding target dir without canonicalize


---

diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index f05a927..0145a38 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -82,19 +82,25 @@ pub(crate) fn include_dir(prj: &Project) -> PathBuf {
 }
 
 pub(crate) fn search_parents_for_target_dir(out_dir: &Path) -> TargetDir {
-    let mut dir = match out_dir.canonicalize() {
-        Ok(dir) => dir,
-        Err(_) => return TargetDir::Unknown,
-    };
+    let mut dir = out_dir.to_owned();
+    let mut also_try_canonical = true;
     loop {
         let is_target = dir.ends_with("target");
         let parent_contains_cargo_toml = dir.with_file_name("Cargo.toml").exists();
         if is_target && parent_contains_cargo_toml {
             return TargetDir::Path(dir);
         }
-        if !dir.pop() {
-            return TargetDir::Unknown;
+        if dir.pop() {
+            continue;
+        }
+        if also_try_canonical {
+            if let Ok(canonical_dir) = out_dir.canonicalize() {
+                dir = canonical_dir;
+                also_try_canonical = false;
+                continue;
+            }
         }
+        return TargetDir::Unknown;
     }
 }
 

